//
//  SACommon.h
//  SocialAuth
//
//  Created by Dan Fleming on 10/26/12.
//  Copyright (c) 2012 Dan Fleming. All rights reserved.
//

// Built-in base configurations
#define kSAServiceTwitterWebAuth       @"TwitterWebAuth"
#define kSAServiceFoursquare           @"Foursquare"
#define kSAServiceTumblr               @"Tumblr"
#define kSAServiceInstagram            @"Instagram"
#define kSAServiceGithub               @"Github"

// Basic authentication keys
#define kSAConfigInternalName          @"InternalName"
#define kSAConfigServiceTitle          @"ServiceTitle"
#define kSAConfigAuthenticatonType     @"AuthenticatonType"
#define kSAAuthenticationTypeOAuth1    @"OAuth1"
#define kSAAuthenticationTypeOAuth2    @"OAuth2"

// Web Authentication
#define kSAConfigWebAuthenticationURL  @"WebAuthenticationURL"
#define kSAConfigWebBaseDomain         @"WebBaseDomain"

// OAuth1-specific
#define kSAConfigOAuth1ConsumerKey     @"OAuth1ConsumerKey"
#define kSAConfigOAuth1ConsumerSecret  @"OAuth1ConsumerSecret"
#define kSAConfigOAuth1RedirectURL     @"OAuth1RedirectURL"
#define kSAConfigOAuth1RequestTokenURL @"OAuth1RequestTokenURL"
#define kSAConfigOAuth1AccessTokenURL  @"OAuth1AccessTokenURL"
#define kSADataOAuth1AccessToken       @"OAuth1AccessToken"
#define kSADataOAuth1TokenSecret       @"OAuth1TokenSecret"

// OAuth2-specific
#define kSAConfigOAuth2ClientID        @"OAuth2ClientID"
#define kSAConfigOAuth2RedirectURL     @"OAuth2RedirectURL"
#define kSAConfigOAuth2Scope           @"OAuth2Scope"
#define kSADataOAuth2AccessToken       @"OAuth2AccessToken"

// Block callback definitions
typedef void(^SASuccessBlock)(NSDictionary *data);
typedef void(^SAFailureBlock)(NSError *error);
typedef void(^SACancelBlock)();
typedef void(^SADismissalBlock)();

// Authentication delegate methods
@protocol SAAuthenticationDelegate<NSObject>
@optional
-(void) clientAuthentication:(NSDictionary*)config didSucceed:(NSDictionary*)data;
-(void) clientAuthentication:(NSDictionary*)config didFail:(NSError*)error;
-(void) clientAuthenticationWasCancelled:(NSDictionary*)config;
@end