//
//  SAViewController.h
//  SocialAuth
//
//  Created by Dan Fleming on 10/26/12.
//  Copyright (c) 2012 Dan Fleming. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "SACommon.h"

// Base view controller
@interface SAViewController : UIViewController
@property(nonatomic,readonly) NSDictionary *config;
@property(nonatomic,weak)     id<SAAuthenticationDelegate> delegate;
@property(nonatomic,strong)   SADismissalBlock dismissalBlock;

-(id) initWithConfig:(NSDictionary*)config delegate:(id<SAAuthenticationDelegate>)delegate;
-(id) initWithConfig:(NSDictionary*)config;
-(void) cancelAuthentication;
@end

//  Web view controllers
@interface SAWebViewController : SAViewController <UIWebViewDelegate>
@property(nonatomic,readonly) UIWebView *webView;
@end

@interface SAOAuth1WebViewController : SAWebViewController
@end

@interface SAOAuth2WebViewController : SAWebViewController
@end